/*
 * Szegedi Tudományegyetem
 * Informatikai Tanszékcsoport
 * Szoftverfejlesztés Tanszék
 *
 * Gergely Tamás, 2008. őszi félév.
 * $Id: huto.h 1168 2010-09-24 10:02:51Z gertom $
 *
 * Ez a fájl az SZTE Programozás Alapjai kurzusához készült.
 * A fájl NEM SZABVÁNYOS C header fájl, mert a függvények törzsét is
 * tartalmazza, de így egyszerűbb a használata.
 *
 * Használat:
 *
 * A c forrásprogram elejére kell beírni az
 *	#include "huto.h"
 * sort, ezek után használhatóak lesznek az alábbi függvények:
 */

#ifndef HUTO_H
#define HUTO_H

#include <stdio.h>
#include <string.h>

void huto_nyitas();         // hűtőajtó kinyitása
void huto_csukas();         // hűtőajtó becsukása
void betesz_hutobe(char*);  // betevés hűtőbe (mit)
void kivesz_hutobol(char*); // kivétel hűtőből (mit)

/* A következő rész tartalmazza a fenti függvények implementációját, e
 * miatt nem szabványos ez a C header fájl.
 */

enum ajto_allapot { csukva, nyitva };

enum ajto_allapot hutoajto = csukva;
char hutotartalom[256] = "";

#define zzz(a) ((*(a) == 'a' || *(a) == 'e' || *(a) == 'i' || *(a) == 'o' || *(a) == 'u' || \
		 *(a) == 'A' || *(a) == 'E' || *(a) == 'I' || *(a) == 'O' || *(a) == 'U') \
		 ? "az" : "a")

void huto_nyitas()
{
	if(hutoajto == csukva) {
		hutoajto = nyitva;
		printf("Kinyitom a hutoajtot.\n");
	} else {
		printf("Nem tudom kinyitni a hutoajtot, mert mar nyitva van.\n");
	}
}

void huto_csukas()
{
	if(hutoajto == nyitva) {
		hutoajto = csukva;
		printf("Becsukom a hutoajtot.\n");
	} else {
		printf("Nem tudom becsukni a hutoajtot, mert mar csukva van.\n");
	}
}

void betesz_hutobe(char* mit)
{
	if(hutoajto == nyitva) {
		if(strcmp(hutotartalom, "") == 0) {
			strcpy(hutotartalom, mit);
			printf("Beteszem a hutobe %s %sot.\n", zzz(mit), mit);
		} else {
			printf("A hutoben mar van egy %s, igy nem tudok betenni semmi mast,\n\tfoleg nem egy %sot.\n", hutotartalom, mit);
		}
	} else {
		printf("Csukott ajton keresztul nem tudom betenni %s %sot.\n", zzz(mit), mit);
	}
}

void kivesz_hutobol(char* mit)
{
	if(hutoajto == nyitva) {
		if(strcmp(hutotartalom, mit) == 0) {
			strcpy(hutotartalom, "");
			printf("Kiveszem a hutobol %s %sot.\n", zzz(mit), mit);
		} else {
			printf("A hutoben egy %s van, nem egy %s. Inkabb benthagyom.\n", hutotartalom, mit);
		}
	} else {
		printf("Csukott ajton keresztul nem tudok kivenni semmit.\n");
	}
}

#endif
